# coding: utf-8

"""
    Kimai 2 - API Docs

    JSON API for the Kimai 2 time-tracking software. Read more about its usage in the [API documentation](https://www.kimai.org/documentation/rest-api.html) and then download a [Swagger file](doc.json) for import e.g. in Postman. Be aware: it is not yet considered stable and BC breaks might happen, but we try to avoid them.   # noqa: E501

    OpenAPI spec version: 0.4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class TimesheetEditForm(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'begin': 'datetime',
        'end': 'datetime',
        'duration': 'str',
        'project': 'int',
        'activity': 'int',
        'description': 'str',
        'tags': 'str',
        'fixed_rate': 'float',
        'hourly_rate': 'float'
    }

    attribute_map = {
        'begin': 'begin',
        'end': 'end',
        'duration': 'duration',
        'project': 'project',
        'activity': 'activity',
        'description': 'description',
        'tags': 'tags',
        'fixed_rate': 'fixedRate',
        'hourly_rate': 'hourlyRate'
    }

    def __init__(self, begin=None, end=None, duration=None, project=None, activity=None, description=None, tags=None, fixed_rate=None, hourly_rate=None):  # noqa: E501
        """TimesheetEditForm - a model defined in Swagger"""  # noqa: E501

        self._begin = None
        self._end = None
        self._duration = None
        self._project = None
        self._activity = None
        self._description = None
        self._tags = None
        self._fixed_rate = None
        self._hourly_rate = None
        self.discriminator = None

        self.begin = begin
        if end is not None:
            self.end = end
        if duration is not None:
            self.duration = duration
        self.project = project
        self.activity = activity
        if description is not None:
            self.description = description
        if tags is not None:
            self.tags = tags
        if fixed_rate is not None:
            self.fixed_rate = fixed_rate
        if hourly_rate is not None:
            self.hourly_rate = hourly_rate

    @property
    def begin(self):
        """Gets the begin of this TimesheetEditForm.  # noqa: E501


        :return: The begin of this TimesheetEditForm.  # noqa: E501
        :rtype: datetime
        """
        return self._begin

    @begin.setter
    def begin(self, begin):
        """Sets the begin of this TimesheetEditForm.


        :param begin: The begin of this TimesheetEditForm.  # noqa: E501
        :type: datetime
        """
        if begin is None:
            raise ValueError("Invalid value for `begin`, must not be `None`")  # noqa: E501

        self._begin = begin

    @property
    def end(self):
        """Gets the end of this TimesheetEditForm.  # noqa: E501


        :return: The end of this TimesheetEditForm.  # noqa: E501
        :rtype: datetime
        """
        return self._end

    @end.setter
    def end(self, end):
        """Sets the end of this TimesheetEditForm.


        :param end: The end of this TimesheetEditForm.  # noqa: E501
        :type: datetime
        """

        self._end = end

    @property
    def duration(self):
        """Gets the duration of this TimesheetEditForm.  # noqa: E501


        :return: The duration of this TimesheetEditForm.  # noqa: E501
        :rtype: str
        """
        return self._duration

    @duration.setter
    def duration(self, duration):
        """Sets the duration of this TimesheetEditForm.


        :param duration: The duration of this TimesheetEditForm.  # noqa: E501
        :type: str
        """

        self._duration = duration

    @property
    def project(self):
        """Gets the project of this TimesheetEditForm.  # noqa: E501

        Project ID  # noqa: E501

        :return: The project of this TimesheetEditForm.  # noqa: E501
        :rtype: int
        """
        return self._project

    @project.setter
    def project(self, project):
        """Sets the project of this TimesheetEditForm.

        Project ID  # noqa: E501

        :param project: The project of this TimesheetEditForm.  # noqa: E501
        :type: int
        """
        if project is None:
            raise ValueError("Invalid value for `project`, must not be `None`")  # noqa: E501

        self._project = project

    @property
    def activity(self):
        """Gets the activity of this TimesheetEditForm.  # noqa: E501

        Activity ID  # noqa: E501

        :return: The activity of this TimesheetEditForm.  # noqa: E501
        :rtype: int
        """
        return self._activity

    @activity.setter
    def activity(self, activity):
        """Sets the activity of this TimesheetEditForm.

        Activity ID  # noqa: E501

        :param activity: The activity of this TimesheetEditForm.  # noqa: E501
        :type: int
        """
        if activity is None:
            raise ValueError("Invalid value for `activity`, must not be `None`")  # noqa: E501

        self._activity = activity

    @property
    def description(self):
        """Gets the description of this TimesheetEditForm.  # noqa: E501


        :return: The description of this TimesheetEditForm.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this TimesheetEditForm.


        :param description: The description of this TimesheetEditForm.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def tags(self):
        """Gets the tags of this TimesheetEditForm.  # noqa: E501

        Comma separated list of tags  # noqa: E501

        :return: The tags of this TimesheetEditForm.  # noqa: E501
        :rtype: str
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this TimesheetEditForm.

        Comma separated list of tags  # noqa: E501

        :param tags: The tags of this TimesheetEditForm.  # noqa: E501
        :type: str
        """

        self._tags = tags

    @property
    def fixed_rate(self):
        """Gets the fixed_rate of this TimesheetEditForm.  # noqa: E501

        Fixed rate  # noqa: E501

        :return: The fixed_rate of this TimesheetEditForm.  # noqa: E501
        :rtype: float
        """
        return self._fixed_rate

    @fixed_rate.setter
    def fixed_rate(self, fixed_rate):
        """Sets the fixed_rate of this TimesheetEditForm.

        Fixed rate  # noqa: E501

        :param fixed_rate: The fixed_rate of this TimesheetEditForm.  # noqa: E501
        :type: float
        """

        self._fixed_rate = fixed_rate

    @property
    def hourly_rate(self):
        """Gets the hourly_rate of this TimesheetEditForm.  # noqa: E501

        Hourly rate  # noqa: E501

        :return: The hourly_rate of this TimesheetEditForm.  # noqa: E501
        :rtype: float
        """
        return self._hourly_rate

    @hourly_rate.setter
    def hourly_rate(self, hourly_rate):
        """Sets the hourly_rate of this TimesheetEditForm.

        Hourly rate  # noqa: E501

        :param hourly_rate: The hourly_rate of this TimesheetEditForm.  # noqa: E501
        :type: float
        """

        self._hourly_rate = hourly_rate

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TimesheetEditForm, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TimesheetEditForm):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
